function ShowSpawnObjectClick(sender)
	form_show(SpawnObjectDlg)
end

function EnableObjPlacementClick(sender)
	EnableObjectSpawning()
	control_setEnabled(SpawnObjectDlg_SpawnObject, true)
	control_setEnabled(SpawnObjectDlg_ReplaceObject, true)
	control_setEnabled(SpawnObjectDlg_SpawnCylinder, true)
	debugProcess()
end

function EnableObjectSpawning()
	local hookaddr = allocateSharedMemory(1024)
	hookcmd = LoadBinaryFile("sa2lua/hook.bin", hookaddr) + hookaddr
	writeInteger(hookaddr + 0x02, hookcmd)
	writeBytes(0x77E780, 0xE9)
	writeInteger(0x77E781, hookaddr - 0x77E785)
	writeBytes(hookcmd, 0x00)
end

function SpawnObject(routine, name, flags, list, customname, xpos, ypos, zpos, delay)
	local nameaddr = name
	if readInteger(hookcmd) == nil then
		print("Object spawning not enabled!")
		return nil
	end
	if customname then
		nameaddr = allocateSharedMemory(string.len(name) + 1)
		writeString(nameaddr, name)
	end
	
	writeBytes(hookcmd, 0x01) -- tell the injected code to spawn an object
	writeInteger(hookcmd + 0x01, routine)
	writeInteger(hookcmd + 0x05, nameaddr)
	writeBytes(hookcmd + 0x09, flags)
	writeInteger(hookcmd + 0x0a, list)
	writeFloat(hookcmd + 0x0e, xpos)
	writeFloat(hookcmd + 0x12, ypos)
	writeFloat(hookcmd + 0x16, zpos)
	
	if delay > 0 then sleep(delay) end
	
	if readBytes(hookcmd, 1, false) == 0 then
		return readInteger(hookcmd + 0x01)
	else
		return nil
	end
end

function SpawnCylinderClick(sender)
	local xpos = readFloat(GetObjData1(readInteger(0x1DEA6E0), 0x14))
	local ypos = readFloat(GetObjData1(readInteger(0x1DEA6E0), 0x18))
	local zpos = readFloat(GetObjData1(readInteger(0x1DEA6E0), 0x1C))
	objaddr = SpawnObject(0x6D6EE0, "Movable Cylinder", 3, 2, true, xpos, ypos, zpos, 0)
	OCUpdateControls()
end

function SpawnObjectClick(sender)
	local routine = tonumber(control_getCaption(SpawnObjectDlg_MainRoutine), 16)
	local flags = tonumber(control_getCaption(SpawnObjectDlg_Flags), 16)
	local list = tonumber(control_getCaption(SpawnObjectDlg_ListID), 16)
	local customname = (objname == 0)
	local xpos = readFloat(GetObjData1(readInteger(0x1DEA6E0), 0x14))
	local ypos = readFloat(GetObjData1(readInteger(0x1DEA6E0), 0x18))
	local zpos = readFloat(GetObjData1(readInteger(0x1DEA6E0), 0x1C))
	if customname then name = control_getCaption(SpawnObjectDlg_ObjectName) else name = objname end
	objaddr = SpawnObject(routine, name, flags, list, customname, xpos, ypos, zpos, 0)
	OCUpdateControls()
end

function ReplaceObjectClick(sender)
	local routine = tonumber(control_getCaption(SpawnObjectDlg_MainRoutine), 16)
	local flags = tonumber(control_getCaption(SpawnObjectDlg_Flags), 16)
	local list = tonumber(control_getCaption(SpawnObjectDlg_ListID), 16)
	local customname = (objname == 0)
	if customname then name = control_getCaption(SpawnObjectDlg_ObjectName) else name = objname end	
	local xpos = readFloat(GetObjData1(objaddr, 0x14))
	local ypos = readFloat(GetObjData1(objaddr, 0x18))
	local zpos = readFloat(GetObjData1(objaddr, 0x1C))
	writeInteger(objaddr + 0x10, 0x46F720) -- Delete the selected object
	local obj = SpawnObject(routine, name, flags, list, customname, xpos, ypos, zpos, 0)
	objaddr = obj
	OCUpdateControls()
end

function PopulateObjListClick(sender)
	local objlist = readInteger(0x1DDE268)
	local count = readInteger(objlist)
	objlist = readInteger(objlist + 0x04)
	ol_name = {}
	ol_namestr = {}
	ol_flags = {}
	ol_list = {}
	ol_routine = {}
	for i=0,count-1 do
		local name = readInteger(objlist + 0x0C), 64
		local flags = readBytes(objlist, 1, false)
		local list = readBytes(objlist + 0x01, 1, false)
		local routine = readInteger(objlist + 0x08)
		table.insert(ol_name, name)
		table.insert(ol_namestr, readString(name, 64))
		table.insert(ol_flags, flags)
		table.insert(ol_list, list)
		table.insert(ol_routine, routine)
		objlist = objlist + 0x10
	end
	local lbitems = listbox_getItems(SpawnObjectDlg_ObjectList)
	strings_clear(lbitems)
	for i,v in ipairs(ol_namestr) do
		strings_add(lbitems, v)
	end
end

function ObjectListSelectionChange(sender, user)
	local index = listbox_getItemIndex(sender) + 1
	objname = ol_name[index]
	control_setCaption(SpawnObjectDlg_ObjectName, ol_namestr[index])
	control_setCaption(SpawnObjectDlg_MainRoutine, num2hex(ol_routine[index]))
	control_setCaption(SpawnObjectDlg_Flags, num2hex(ol_flags[index]))
	control_setCaption(SpawnObjectDlg_ListID, num2hex(ol_list[index]))
end

function ObjectNameChange(sender)
	local index = listbox_getItemIndex(SpawnObjectDlg_ObjectList) + 1
	local defaultname = ol_namestr[index]
	if control_getCaption(sender) ~= defaultname then
		objname = 0
	else
		objname = ol_name[index]
	end
end

function CheckForSpawnedObject()
	if hookcmd ~= nil and readBytes(hookcmd, 1, false) == 0xFF then
		writeBytes(hookcmd, 0x00)
		objaddr = readInteger(hookcmd + 0x01)
		OCUpdateControls()
		UpdateRemote()
	end
end

hookcmd = nil
objname = 0
ol_name = {}
ol_namestr = {}
ol_flags = {}
ol_list = {}
ol_routine = {}
control_setEnabled(SpawnObjectDlg_SpawnObject, false)
control_setEnabled(SpawnObjectDlg_ReplaceObject, false)
control_setEnabled(SpawnObjectDlg_SpawnCylinder, false)
strings_clear(listbox_getItems(SpawnObjectDlg_ObjectList))